<!---
	Name:			/Application.cfm
	Last Updated:	January 3, 2006
	Comments: 		Leave this commented out if on CFMX 7 or greater

<cferror type="EXCEPTION" template="error.cfm">--->

<cfapplication 	name="LighthousePro" 
				sessionmanagement="Yes"
               	sessiontimeout="#createTimeSpan(0,0,20,0)#"
               	applicationtimeout="#createTimeSpan(0,2,0,0)#">

				
<cfif isDefined("url.reinit")>
	<cfset application.started = false>
</cfif>

<!--- was onRequest --->
<cfinclude template="includes/udfs.cfm">
		
<cfif not isdefined("application.started") or not application.started>
	<cfset xmlFile = "">
	<cfset xmlData = "">
	<cfset rootDir = getDirectoryFromPath(getCurrentTemplatePath())>
	<cfset key = "">
	<cfset groups = "">
	
	<!--- load settings --->
	<cffile action="read" file="#rootdir#/defaults.cfm" variable="xmlFile">
	<!--- Remove comments --->
	<cfset xmlFile = replace(xmlFile, "<!---","")>
	<cfset xmlFile = trim(replace(xmlFile, "--->",""))>
	
	<cfset xmlData = xmlParse(xmlFile)>
	<cfloop item="key" collection="#xmlData.initvals.defaults#">
		<cfset application[key] = xmlData.initvals.defaults[key].xmlText>
	</cfloop>

	<cfset application.attachmentPath = rootDir & "attachments">
	
	<cfset application.userDAO = createObject("component","components.UserDAO").init(application.dsn)>
	<cfset application.userManager = createObject("component","components.UserManager").init(application.dsn)>

	<cfset application.projectDAO = createObject("component","components.ProjectDAO").init(application.dsn)>
	<cfset application.projectManager = createObject("component","components.ProjectManager").init(application.dsn)>

	<cfset application.projectLocusDAO = createObject("component","components.ProjectLocusDAO").init(application.dsn)>
	<cfset application.projectLocusManager = createObject("component","components.ProjectLocusManager").init(application.dsn)>

	<cfset application.issueDAO = createObject("component","components.IssueDAO").init(application.dsn,application.attachmentpath)>
	<cfset application.issueManager = createObject("component","components.IssueManager").init(application.dsn,application.adminemail,application.mailusername,application.mailpassword,application.attachmentpath)>
	
	<!--- Our security system is pretty simple. While we do have users and groups, we really only use the
		  admin group as a flag. To speed things up a bit later on, we are going to get the ID for "Admin"
		  so we can cache it.
	--->
	<cfset application.admingroupid = "">
	<cfset groups = application.userManager.getGroups()>
	<cfloop query="groups">
		<cfif name is "admin">
			<cfset application.admingroupid = id>
		</cfif>
	</cfloop>
	
	<!--- cache status and severity values for issues --->
	<cfset application.statuses = application.issueManager.getStatuses()>
	<cfset application.severities = application.issueManager.getSeverities()>
	
	<!--- used for CFMX 6.1 --->
	<cfset application.started = true>
</cfif>

<!--- Was onRequestStart --->	
<cfset showLogin = true>
<cfset roles = "">
<cfset auth = "">

<cfif isDefined("url.logout")>
	<cflogout>
</cfif>

<cfsetting enablecfoutputonly=true>

<cfif isDefined("url.auth")>
	<cfset auth = decrypt(url.auth, application.secretkey)>
	<cfset form.username = listLast(listFirst(auth, "&"),"=")>
	<cfset form.password = listLast(listLast(auth, "&"),"=")>
	<cfset form.login = 1>
</cfif>

<cflogin>

	<cfif isDefined("form.login") and isDefined("form.username") and isDefined("form.password")>
		<cfif application.userManager.authenticate(form.username, form.password)>
			<cfset session.userBean = application.userManager.getUserByUsername(form.username)>
			<cfset roles = application.userManager.getGroupsForUser(session.userBean.getID())>
			<cfset showLogin = false>
			<cfloginuser name="#form.username#" password="#form.password#" roles="#roles#">
		</cfif>
	</cfif>
	
	<cfif showLogin>
		<cfinclude template="login.cfm">
		<cfabort>
	</cfif>
</cflogin>