<cfcomponent output="false" displayName="User DAO" hint="Does DAO for Issues">

	<cfset variables.dsn = "">
	
	<cffunction name="init" access="public" returnType="IssueDAO" output="false">
		<cfargument name="dsn" type="string" required="true">
		<cfargument name="attachmentpath" type="string" required="true">
		
		<cfset variables.dsn = arguments.dsn>
		<cfset variables.attachmentpath = arguments.attachmentpath>
		
		<cfreturn this>
	</cffunction>
	
	<cffunction name="create" access="public" returnType="IssueBean" output="false">
		<cfargument name="iBean" type="IssueBean" required="true">
		<cfset var insRec = "">
		<cfset var newID = createUUID()>
		
		<cfquery name="insRec" datasource="#variables.dsn#">
			insert into issues(id,projectidfk,created,updated,name,useridfk,description,history,isbug,locusidfk,severityidfk,statusidfk,relatedURL,attachment)
			values(
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#newid#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getProjectIDFK()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_timestamp" value="#arguments.iBean.getCreated()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_timestamp" value="#arguments.iBean.getUpdated()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getName()#" maxlength="255">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getUserIDFK()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_longvarchar" value="#arguments.iBean.getDescription()#">,
				<cfqueryparam cfsqltype="cf_sql_longvarchar" value="#arguments.iBean.getHistory()#">,
				<cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.iBean.getIsBug()#">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getLocusIDFK()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getSeverityIDFK()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getStatusIDFK()#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getRelatedURL()#" maxlength="255">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getAttachment()#" maxlength="255">
				)
		</cfquery>
			
		<cfset iBean.setID(newid)>
				
		<cfreturn iBean>
	</cffunction>
	
	<cffunction name="delete" access="public" returnType="void" output="false">
		<cfargument name="id" type="uuid" required="true">
		<cfset var issue = read(arguments.id)>
		
		<cfquery datasource="#variables.dsn#">
		delete from issues
		where id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
		
		<!--- clean up file --->
		<cfif issue.getAttachment() neq "">
			<cffile action="delete" file="#variables.attachmentpath#/#issue.getAttachment()#">
		</cfif>
						
	</cffunction>
	
	<cffunction name="read" access="public" returnType="IssueBean" output="false">
		<cfargument name="id" type="uuid" required="true">
		<cfset var iBean = createObject("component","IssueBean")>
		<cfset var getit = "">
		
		<cfquery name="getit" datasource="#variables.dsn#">
			select 	id, projectidfk, created, updated, name, useridfk, description, history, isbug, locusidfk, severityidfk, statusidfk, relatedurl, attachment
			from	issues
			where	id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
		
		<cfif getit.recordCount>
			<cfset iBean.setID(getit.id)>
			<cfset iBean.setProjectIDFK(getit.projectidfk)>
			<cfset iBean.setCreated(getit.created)>
			<cfset iBean.setUpdated(getit.updated)>
			<cfset iBean.setName(getit.name)>
			<cfset iBean.setUserIDFK(getit.useridfk)>
			<cfset iBean.setDescription(getit.description)>
			<cfset iBean.setHistory(getit.history)>
			<cfset iBean.setIsBug(getit.isbug)>
			<cfset iBean.setLocusIDFK(getit.locusidfk)>
			<cfset iBean.setSeverityIDFK(getit.severityidfk)>
			<cfset iBean.setStatusIDFK(getit.statusidfk)>
			<cfset iBean.setRelatedURL(getit.relatedurl)>
			<cfset iBean.setAttachment(getit.attachment)>
		</cfif>
		
		<cfreturn iBean>
	</cffunction>

	<cffunction name="update" returnType="IssueBean" access="public" output="false">
		<cfargument name="iBean" type="IssueBean" required="true">

		<cfquery datasource="#variables.dsn#">
		update issues
		set	projectidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getProjectIDFK()#" maxlength="35">,
			created = <cfqueryparam cfsqltype="cf_sql_timestamp" value="#arguments.iBean.getCreated()#" maxlength="35">,
			updated = <cfqueryparam cfsqltype="cf_sql_timestamp" value="#arguments.iBean.getUpdated()#" maxlength="35">,
			name = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getName()#" maxlength="255">,
			useridfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getUserIDFK()#" maxlength="35">,
			description = <cfqueryparam cfsqltype="cf_sql_longvarchar" value="#arguments.iBean.getDescription()#">,
			history = <cfqueryparam cfsqltype="cf_sql_longvarchar" value="#arguments.iBean.getHistory()#">,
			isbug = <cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.iBean.getIsBug()#">,
			locusidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getLocusIDFK()#" maxlength="35">,
			severityidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getSeverityIDFK()#" maxlength="35">,
			statusidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getStatusIDFK()#" maxlength="35">,
			relatedurl = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getRelatedURL()#" maxlength="255">,
			attachment = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getAttachment()#" maxlength="255">
			where id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.iBean.getID()#" maxlength="35">
		</cfquery>				

		<cfreturn arguments.iBean>
	</cffunction>
	
</cfcomponent>