<cfcomponent output="false" displayName="User DAO" hint="Does DAO for Project">

	<cfset variables.dsn = "">
	
	<cffunction name="init" access="public" returnType="ProjectDAO" output="false">
		<cfargument name="dsn" type="string" required="true">
		
		<cfset variables.dsn = arguments.dsn>
		
		<cfreturn this>
	</cffunction>
	
	<cffunction name="create" access="public" returnType="ProjectBean" output="false">
		<cfargument name="pBean" type="ProjectBean" required="true">
		<cfset var insRec = "">
		<cfset var newID = createUUID()>
		
			
		<cfquery name="insRec" datasource="#variables.dsn#">
			insert into projects(id,name)
			values(
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#newid#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.pBean.getName()#" maxlength="50">
				)
		</cfquery>
			
		<cfset pBean.setID(newid)>
		
		<cfreturn pBean>
	</cffunction>
	
	<cffunction name="delete" access="public" returnType="void" output="false">
		<cfargument name="id" type="uuid" required="true">

		<cfquery datasource="#variables.dsn#">
		delete from projects
		where id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
			
		<!--- clean up users --->
		<cfquery datasource="#variables.dsn#">
		delete from projects_users
		where projectidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
		
		<!--- clean up loci links --->
		<cfquery datasource="#variables.dsn#">
		delete from projects_projectloci
		where projectidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>

		<!--- remove subscribed people --->		
		<cfquery datasource="#variables.dsn#">
		delete from projects_users_email
		where projectidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>

		<!--- remove issues --->	
		<cfquery datasource="#variables.dsn#">
		delete from issues
		where projectidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>

	</cffunction>
	
	<cffunction name="read" access="public" returnType="ProjectBean" output="false">
		<cfargument name="id" type="uuid" required="true">
		<cfset var pBean = createObject("component","ProjectBean")>
		<cfset var getit = "">
		
		<cfquery name="getit" datasource="#variables.dsn#">
			select 	id, name
			from	projects
			where	id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
		
		<cfif getit.recordCount>
			<cfset pBean.setID(getit.id)>
			<cfset pBean.setName(getit.name)>
		</cfif>
		
		<cfreturn pBean>
	</cffunction>

	<cffunction name="update" returnType="ProjectBean" access="public" output="false">
		<cfargument name="ProjectBean" type="ProjectBean" required="true">

		<cfquery datasource="#variables.dsn#">
		update projects
		set name = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ProjectBean.getName()#" maxlength="50">
		where id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ProjectBean.getID()#" maxlength="35">
		</cfquery>
		
		<cfreturn arguments.ProjectBean>
	</cffunction>
	
</cfcomponent>