<cfcomponent output="false" displayName="User DAO" hint="Does DAO for Project Loci">

	<cfset variables.dsn = "">
	
	<cffunction name="init" access="public" returnType="ProjectLocusDAO" output="false">
		<cfargument name="dsn" type="string" required="true">
		
		<cfset variables.dsn = arguments.dsn>
		
		<cfreturn this>
	</cffunction>
	
	<cffunction name="create" access="public" returnType="ProjectLocusBean" output="false">
		<cfargument name="pBean" type="ProjectLocusBean" required="true">
		<cfset var insRec = "">
		<cfset var newID = createUUID()>
		
			
		<cfquery name="insRec" datasource="#variables.dsn#">
			insert into projectloci(id,name)
			values(
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#newid#" maxlength="35">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.pBean.getName()#" maxlength="50">
				)
		</cfquery>
			
		<cfset pBean.setID(newid)>
		
		<cfreturn pBean>
	</cffunction>
	
	<cffunction name="delete" access="public" returnType="void" output="false">
		<cfargument name="id" type="uuid" required="true">

		<cfquery datasource="#variables.dsn#">
		delete from projectloci
		where id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
		
		<!--- clean up --->
		<cfquery datasource="#variables.dsn#">
		delete from projects_projectloci
		where projectlociidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
						
	</cffunction>
	
	<cffunction name="read" access="public" returnType="ProjectLocusBean" output="false">
		<cfargument name="id" type="uuid" required="true">
		<cfset var pBean = createObject("component","ProjectLocusBean")>
		<cfset var getit = "">
		
		<cfquery name="getit" datasource="#variables.dsn#">
			select 	id, name
			from	projectloci
			where	id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.id#" maxlength="35">
		</cfquery>
		
		<cfif getit.recordCount>
			<cfset pBean.setID(getit.id)>
			<cfset pBean.setName(getit.name)>
		</cfif>
		
		<cfreturn pBean>
	</cffunction>

	<cffunction name="update" returnType="ProjectLocusBean" access="public" output="false">
		<cfargument name="ProjectLocusBean" type="ProjectLocusBean" required="true">

		<cfquery datasource="#variables.dsn#">
		update projectloci
		set name = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ProjectLocusBean.getName()#" maxlength="50">
		where id = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ProjectLocusBean.getID()#" maxlength="35">
		</cfquery>
		
		<cfreturn arguments.ProjectLocusBean>
	</cffunction>
	
</cfcomponent>