<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\index.cfm
	Author       : Raymond Camden 
	Created      : 3/4/04
	Last Updated : 12/22/05
	History      : version 2.0 is in the house... (rkc 12/22/05)
--->

<cfmodule template="customtags/layout.cfm">

	<cfoutput>
	<h1 id="welcome" style="border-top: none; padding-top: 0;">Welcome to Lighthouse Pro</h1>
	<p>
	Welcome to Lighthouse Pro, a web based bug and issue tracker. To begin using Lighthouse Pro, simply
	select from one of the projects in the left hand menu. You may update your preferences or logout from
	the left hand menu as well.
	</p>
	
	<p>
	This is version 2.0 of Lighthouse Pro. It was created by <a href="http://ray.camdenfamily.com">Raymond Camden</a>.
	</p>	
	
	<h1 id="quickstats" style="border-top: none; padding-top: 0;">Quick Stats</h1>
	</cfoutput>
	
	<cfset userid = application.userManager.getUserByUsername(getAuthUser()).getID()>
	<cfset issues = application.issueManager.getIssuesForUserID(userid)>

	<cfquery name="openissues" dbtype="query">
	select 	count(id) as openissues
	from	issues
	where	statusname = 'Open'
	</cfquery>

	<cfquery name="mostrecent" dbtype="query" maxrows="1">
	select 	created, id, name
	from	issues
	where	statusname = 'Open'
	order by created desc
	</cfquery>

	<cfquery name="oldest" dbtype="query" maxrows="1">
	select 	created, id, name
	from	issues
	where	statusname = 'Open'
	order by created asc
	</cfquery>
	
	<cfquery name="numbyproject" dbtype="query">
	select 		count(id) as numissues, projectname, projectidfk
	from		issues
	where		statusname = 'Open'
	group by	projectidfk, projectname
	</cfquery>
	
	<cfoutput>
	<p>
	You currently have #issues.recordCount# issue(s) assigned to you.<br />
	<cfif issues.recordCount gte 1>
		Of those issues, #openissues.openissues# issue(s) are marked as open.<br />
		<cfif mostrecent.recordcount>
		Your most recent (#dateFormat(mostrecent.created, "short")# #timeFormat(mostrecent.created, "short")#) open issue is: <b><a href="view.cfm?id=#mostrecent.id#">#mostrecent.name#</a></b><br />
		</cfif>
		<cfif oldest.recordcount>
		Your oldest (#dateFormat(oldest.created, "short")# #timeFormat(oldest.created, "short")#) open issue is: <b><a href="view.cfm?id=#oldest.id#">#oldest.name#</a></b><br />
		</cfif>
		<cfloop query="numbyproject">
		Project <a href="project_view.cfm?id=#projectidfk#">#projectname#</a> has #numissues# open issue(s).<br/>
		</cfloop>
	</cfif>
	</p>
	</cfoutput>
		
</cfmodule>