CREATE TABLE LIGHTHOUSE.groups ( 
    id VARCHAR2(35) NOT NULL,
    name VARCHAR2(50) NOT NULL
)
GO	

CREATE TABLE LIGHTHOUSE.issues (
	id VARCHAR2(35) NOT NULL ,
	projectidfk VARCHAR2(35) NOT NULL ,
	created DATE NOT NULL ,
	updated DATE NOT NULL ,
	name VARCHAR2(255) NOT NULL ,
	useridfk VARCHAR2(35) NOT NULL ,
	description CLOB NOT NULL ,
	history CLOB NOT NULL ,
	isbug NUMBER NOT NULL ,
	locusidfk VARCHAR2(35) NOT NULL ,
	severityidfk VARCHAR2(35) NOT NULL ,
	statusidfk VARCHAR2(35) NOT NULL ,
	relatedurl VARCHAR2(255) NULL ,
	attachment VARCHAR2(255) NULL,
	PRIMARY KEY(id)
)
GO

CREATE TABLE LIGHTHOUSE.projectloci(
	id VARCHAR2(35) NOT NULL ,
	name VARCHAR2(35) NOT NULL,
	PRIMARY KEY(id)
)
GO

CREATE TABLE LIGHTHOUSE.projects(
	id VARCHAR2(35) NOT NULL ,
	name VARCHAR2(50) NOT NULL 
)
GO

CREATE TABLE LIGHTHOUSE.projects_projectloci(
	projectidfk VARCHAR2(35) NOT NULL ,
	projectlociidfk VARCHAR2(35) NOT NULL 
)
GO

CREATE TABLE LIGHTHOUSE.projects_users(
	projectidfk VARCHAR2(35) NOT NULL ,
	useridfk VARCHAR2(35) NOT NULL 
)
GO

CREATE TABLE LIGHTHOUSE.projects_users_email(
	useridfk VARCHAR2(35) NULL ,
	projectidfk VARCHAR2(35) NULL 
)
GO

CREATE TABLE LIGHTHOUSE.severities(
	id VARCHAR2(35) NOT NULL ,
	rank NUMBER NOT NULL ,
	name VARCHAR2(50) NOT NULL,
	PRIMARY KEY(id) 
)
GO

CREATE TABLE LIGHTHOUSE.statuses(
	id VARCHAR2(35) NOT NULL ,
	rank NUMBER NOT NULL ,
	name VARCHAR2(50) NOT NULL,
	PRIMARY KEY(id) 
)
GO

CREATE TABLE LIGHTHOUSE.users(
	id VARCHAR2(35) NOT NULL ,
	username VARCHAR2(50) NOT NULL ,
	password VARCHAR2(50) NOT NULL ,
	emailaddress VARCHAR2(50) NOT NULL ,
	name VARCHAR2(50) NOT NULL 
)
GO

CREATE TABLE LIGHTHOUSE.users_groups(
	useridfk VARCHAR2(35) NOT NULL ,
	groupidfk VARCHAR2(35) NOT NULL 
)
GO


CREATE UNIQUE INDEX LIGHTHOUSE.issues_PRIMARYKEY
    ON LIGHTHOUSE.issues(id)
GO

CREATE UNIQUE INDEX LIGHTHOUSE.projectloci_PRIMARYKEY
    ON LIGHTHOUSE.projectloci(id)
GO

CREATE UNIQUE INDEX LIGHTHOUSE.severities_PRIMARYKEY
    ON LIGHTHOUSE.severities(id)
GO

CREATE UNIQUE INDEX LIGHTHOUSE.statuses_PRIMARYKEY
    ON LIGHTHOUSE.statuses(id)
GO


INSERT INTO LIGHTHOUSE.groups VALUES ('99C5AACE-92B3-7D72-6E5B4017FD38ACED','admin')
Go

INSERT INTO LIGHTHOUSE.projectloci(id, name) VALUES ('A5EF700C-AB69-4306-4449F6526B7009E4','Front End')
GO
INSERT INTO LIGHTHOUSE.projectloci(id, name) VALUES ('A5EFAF58-9200-29D3-A4CC2FC42580944D','Administration')
GO
INSERT INTO LIGHTHOUSE.projectloci(id, name) VALUES ('A5F0620E-F052-9042-7478FF91A21A420A','Documentation')
GO
INSERT INTO LIGHTHOUSE.projectloci(id, name) VALUES ('A5F174B6-AF3C-D585-4E7BCBABA1403DA5','Design')
GO
INSERT INTO LIGHTHOUSE.projectloci(id, name) VALUES ('A5F47B30-BB4C-8AB5-3524012968ACD958','Database')
GO
INSERT INTO LIGHTHOUSE.projectloci(id, name) VALUES ('D24608FA-D932-FD61-D6A16A505941A5DD','Code')
GO

INSERT INTO LIGHTHOUSE.severities(id, name, rank) VALUES ('B39A54CA-9301-0F14-4A3A11FAB743FC0A','Low',1)
GO
INSERT INTO LIGHTHOUSE.severities(id, name, rank) VALUES ('B39AD7F4-B8B1-2D90-80C3EFB34D77C27B','Normal',2)
GO
INSERT INTO LIGHTHOUSE.severities(id, name, rank) VALUES ('B39AF9E4-A525-B9AE-20F2B6728C98A61B','High',3)
GO

INSERT INTO LIGHTHOUSE.statuses(id, name, rank) VALUES ('B39CBA41-F798-06C7-3C7B89400E935B36','Open',1)
GO
INSERT INTO LIGHTHOUSE.statuses(id, name, rank) VALUES ('B39CDD69-BC54-D278-386E2C062727CCEE','Fixed',2)
GO
INSERT INTO LIGHTHOUSE.statuses(id, name, rank) VALUES ('B39D0043-B9C9-B5CB-85A208D3154A760F','Pending',3)
Go
INSERT INTO LIGHTHOUSE.statuses(id, name, rank) VALUES ('B470E360-2B30-A2D9-801EB67AE122F3A3','Closed',4)
Go

INSERT INTO LIGHTHOUSE.users(id, name, username, password, emailaddress) VALUES ('94CC6A2B-A60E-187D-5BFEA49A0FB60145','admin','admin','password','admin@localhost.com')
GO

INSERT INTO LIGHTHOUSE.users_groups(groupidfk, useridfk) VALUES ('99C5AACE-92B3-7D72-6E5B4017FD38ACED','94CC6A2B-A60E-187D-5BFEA49A0FB60145')
GO
