<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\prefs.cfm
	Author       : Raymond Camden 
	Created      : Earlier
	Last Updated : 12/29/05
	History      : HTML Forms (rkc 12/22/05)
				 : fixed issue when no email sub are picked (rkc 12/29/05)
--->

<cfset message = "">
<cfset errormsg = "">

<cfset uBean = application.userManager.getUserByUsername(getAuthUser())>
<cfset myProjects = application.projectManager.getProjectsForUser()>
<cfset mySubscribedProjects = application.projectManager.getEmailProjectsForUser()>
<cfset mysublist = valueList(mySubscribedProjects.id)>

<cfparam name="form.name" default="#uBean.getName()#">
<cfparam name="form.emailaddress" default="#uBean.getEmailAddress()#">
<cfif not isDefined("form.save")>
	<cfparam name="form.emailProjects" default="#mySubList#">
<cfelse>
	<cfparam name="form.emailProjects" default="">
</cfif>

<cfif isDefined("form.cancel")>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<cfif isDefined("form.save")>
	<cfif len(trim(form.password)) and form.password neq form.password2>
		<cfset errormsg = "Password was not updated. It did not match the confirmation password.<br>">
	</cfif>
	<cfif not len(trim(form.name))>
		<cfset errormsg = "Name cannot be blank.<br>">
	</cfif>
	<cfif not len(trim(form.emailaddress)) or not isValid("email", form.emailaddress)>
		<cfset errormsg = "Email must be valid.<br>">
	</cfif>
	<cfif not len(errormsg)>
		<cfset uBean.setName(trim(form.name))>
		<cfif len(form.password)>
			<cfset uBean.setPassword(trim(form.password))>
		</cfif>
		<cfset uBean.setEmailAddress(trim(form.emailaddress))>
		<!--- update project prefs --->
		<cfset application.projectManager.setEmailProjectsForUser(uBean.getID(),form.emailProjects)>
		<cfset mysublist = form.emailProjects>
		<cftry>
			<cfset application.userDAO.update(ubean)>
			<cfset message = "Your preferences have been updated.<br>">
			<cfcatch>
				<cfset errormsg = cfcatch.message>
			</cfcatch>
		</cftry>
	</cfif>
</cfif>

<cfmodule template="customtags/layout.cfm" title="Preferences">

	<cfoutput>
	<h1 id="preferences" style="border-top: none; padding-top: 0;">Preferences</h1>
	<p>
	Use the form below to update your preferences. Every project selected in the "Email Projects" field will subscribe
	you to that project. You will then get an email every time an issue is created or updated.
	</p>
	</cfoutput>

	<cfif len(message)>
		<cfoutput>
		<p>
		#message#
		</p>
		</cfoutput>
	</cfif>
	
	<cfif len(errormsg)>
		<cfoutput>
		<p>
		<b>The following error(s) has occured:</b><br>
		#errormsg#
		</p>
		</cfoutput>
	</cfif>

	<cfoutput>
	<form action="prefs.cfm" method="post">
	<table border="0">
		<tr>
			<td class="requiredField">Name:</td>
			<td><input type="text" name="name" value="#form.name#" class="textField"></td>
		</tr>
		<tr>
			<td class="requiredField">Email:</td>
			<td><input type="text" name="emailaddress" value="#form.emailaddress#" class="textField"></td>
		</tr>
		<tr>
			<td class="nonrequiredField">New Password:</td>
			<td><input type="password" name="password" value="" class="textField"></td>
		</tr>
		<tr>
			<td class="nonrequiredField">Confirm Password:</td>
			<td><input type="password" name="password2" value="" class="textField"></td>
		</tr>
		<tr>
			<td class="nonrequiredField">Email Projects:</td>
			<td>
			<select name="emailProjects" multiple size="4" class="dropdownField">
			<cfloop query="myProjects">
				<cfoutput><option value="#id#" <cfif listFind(mysublist, id)>selected</cfif>>#name#</option></cfoutput>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="cancel" value="Cancel"> <input type="submit" name="save" value="Save"></td>
		</tr>
	</table>
	</form>
	</cfoutput>
		
</cfmodule>
