<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\project.cfm
	Author       : Raymond Camden 
	Created      : 3/4/04
	Last Updated : 12/30/05
	History      : Version 2(rkc 12/22/05)
				 : Handle no loci, and allow for no users (rkc 12/30/05)
--->

<cfparam name="errormsg" default="">

<cfif isDefined("form.returnProject") or not isDefined("url.id")>
	<cflocation url="projects.cfm" addToken="false">
</cfif>

<cfif isDefined("form.cancel")>
	<cflocation url="projects.cfm" addToken="false">
</cfif>

<cfif isDefined("form.save")>
	<cftry>
		<cfif not isDefined("form.loci")>
			<cfset errormsg = "You must select at least one project loci.">
		<cfelse>
			<cfif url.id eq "0">
				<cfset pBean = createObject("component","components.ProjectBean")>
				<cfset pBean.setName(form.name)>
				<cfset pBean = application.projectDAO.create(pBean)>
				<cfset url.id = pBean.getID()>
			<cfelse>
				<cfset pBean = application.projectDAO.read(url.id)>
				<cfif pBean.getID() neq url.id>
					<cflocation url="projects.cfm" addToken="false">
				</cfif>
				<cfset pBean.setName(form.name)>
				<cfset application.projectDAO.update(pBean)>
			</cfif>
			<cfparam name="form.users" default="">
			<cfset application.projectManager.setLociForProject(pBean.getID(),form.loci)>
			<cfset application.projectManager.setUsersForProject(pBean.getID(),form.users)>
			<cflocation url="projects.cfm" addToken="false">
		</cfif>
		<cfcatch>
			<cfset errormsg = cfcatch.message>
		</cfcatch>
	</cftry>

</cfif>

<cfif url.id neq "0">
	<cfset p = application.projectDAO.read(url.id)>
	<cfif url.id neq p.getID()>
		<cflocation url="projects.cfm" addToken="false">
	</cfif>
	<cfparam name="form.name" default="#p.getName()#">
	<cfset loci = application.projectManager.getLociForProject(url.id)>
	<cfset users = application.projectManager.getUsersForProject(url.id)>
	<cfparam name="form.loci" default="#valueList(loci.id)#">
	<cfparam name="form.users" default="#valueList(users.id)#">
<cfelse>
	<cfparam name="form.name" default="">
	<cfparam name="form.loci" default="">
	<cfparam name="form.users" default="">
</cfif>

<cfset allLoci = application.projectLocusManager.getProjectLoci()>
<cfset allUsers = application.userManager.getUsers()>

<cfmodule template="customtags/layout.cfm" title="Projects">

	<cfoutput>
	<h1 id="project" style="border-top: none; padding-top: 0;">Project Edit</h1>
	<p>
	Use the form below to edit your project. Loci refer to the areas of your project where issues
	may be located. Typical examples include "Database, Front End, Administrator, Components." Only
	selected users will be able to work with issues.
	</p>
	</cfoutput>

	<cfif len(errormsg)>
		<cfoutput>
		<p>
		<b>The following error(s) has occured:</b><br>
		#errormsg#
		</p>
		</cfoutput>
	</cfif>

	<cfoutput>
	<form action="project.cfm?id=#url.id#" method="post">
	<table border="0">
		<tr>
			<td class="requiredField">Name:</td>
			<td><input type="text" name="name" value="#form.name#" class="textField"></td>
		</tr>
		<tr>
			<td class="requiredField">Project Loci:</td>
			<td>
			<select name="loci" multiple size="5" class="dropdownField">
			<cfloop query="allLoci">
				<cfoutput><option value="#id#" <cfif listFind(form.loci, id)>selected</cfif>>#name#</option></cfoutput>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td class="requiredField">Users:</td>
			<td>
			<select name="users" multiple size="5" class="dropdownField">
			<cfloop query="allUsers">
				<cfoutput><option value="#id#" <cfif listFind(form.users, id)>selected</cfif>>#username# (#name#)</option></cfoutput>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="cancel" value="Cancel"> <input type="submit" name="save" value="Save"></td>
		</tr>
	</table>
	</form>
	</cfoutput>

</cfmodule>