<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\project_view.cfm
	Author       : Raymond Camden 
	Created      : 3/18/04
	Last Updated : 1/11/06
	History      : Version 2(rkc 12/22/05)
				 : It wasn't remembering status, nor was it using the right text for filtering (12/30/05)
				 : Added keyword filters (rkc 1/11/06)
--->

<!--- due to a datatable issue, I'm using pid so will copy over --->
<cfif structKeyExists(url, "pid")>
	<cfset url.id = url.pid>
</cfif>

<!--- Require a valud url.id. --->
<cfif not isDefined("url.id") or not len(trim(url.id))>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<!--- Ensure it is a valid project. --->
<cfset p = application.projectDAO.read(url.id)>
<cfif p.getID() neq url.id>
	<cflocation url="index.cfm" addToken="false">
</cfif>
	
<!--- Next ensure that I have rights on the project if not admin. --->
<cfif not isUserInRole("admin")>
	<cfset projects = application.projectManager.getProjectsForUser()>
	<cfset myProjects = valueList(projects.id)>
	<cfif not listFind(myProjects, p.getID())>
		<cflocation url="index.cfm" addToken="false">
	</cfif>
</cfif>

<cfif isDefined("form.mark")>
	<cfloop index="id" list="#form.mark#">
		<cfset application.IssueDAO.delete(id)>
	</cfloop>
</cfif>
	
<cfif isDefined("form.printIssue")>
	<cflocation url="view.cfm?id=#form.data.id#&p=1" addToken="false">
</cfif>
			

<cfparam name="url.bugtype_filter" default="">
<cfparam name="url.loci_filter" default="">
<cfparam name="url.severity_filter" default="">
<cfparam name="url.status_filter" default="B39CBA41-F798-06C7-3C7B89400E935B36">
<cfparam name="url.owner_filter" default="">
<cfparam name="url.keyword_filter" default="">

<!--- get users --->
<cfset possibleUsers = application.projectManager.getUsersForProject(p.getID())>

<!--- get loci --->
<cfset possibleLoci = application.projectManager.getLociForProject(p.getID())> 

<!--- Now get issues for the project --->
<cfset issues = application.issueManager.getIssuesForProject(url.id)>

<!--- add bugtype as a column so we can display it --->
<cfset queryAddColumn(issues,"bugtype",arrayNew(1))>
<cfloop query="issues">
	<cfif isBug>
		<cfset querySetCell(issues,"bugtype","Bug",currentRow)>
	<cfelse>
		<cfset querySetCell(issues,"bugtype","Enhancement",currentRow)>
	</cfif>
</cfloop>

<!--- we use this later in datatable --->
<cfset qs = "pid=#url.id#">

<!--- now do filter --->
<cfquery name="issues" dbtype="query">
	select	*
	from	issues
	where	1=1
	<cfif url.bugtype_filter is not "">
		<cfset qs = qs & "&bugtype_filter=#url.bugtype_filter#">
		<cfset form.filter = 1>
		and	bugtype = <cfqueryparam cfsqltype="cf_sql_varchar" value="#url.bugtype_filter#">
	</cfif>
	<cfif url.loci_filter is not "">
		<cfset qs = qs & "&loci_filter=#url.loci_filter#">
		<cfset form.filter = 1>
		and	locusidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#url.loci_filter#">
	</cfif>
	<cfif url.severity_filter is not "">
		<cfset qs = qs & "&severity_filter=#url.severity_filter#">
		<cfset form.filter = 1>
		and	severityidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#url.severity_filter#">
	</cfif>
	<cfif url.status_filter is not "">
		<cfset qs = qs & "&status_filter=#url.status_filter#">
		<cfset form.filter = 1>		
		and	statusidfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#url.status_filter#">
	</cfif>
	<cfif url.owner_filter is not "">
		<cfset qs = qs & "&owner_filter=#url.owner_filter#">
		<cfset form.filter = 1>		
		and	useridfk = <cfqueryparam cfsqltype="cf_sql_varchar" value="#url.owner_filter#">
	</cfif>
	<cfif url.keyword_filter is not "">
		<cfset qs = qs & "&keyword_filter=#url.keyword_filter#">
		<cfset form.filter = 1>		
		and	(upper(name) like <cfqueryparam cfsqltype="cf_sql_varchar" value="%#uCase(url.keyword_filter)#%">
		     or
		     upper(description) like <cfqueryparam cfsqltype="cf_sql_varchar" value="%#uCase(url.keyword_filter)#%">)
	</cfif>
		
</cfquery>

<cfmodule template="customtags/layout.cfm" title="Issues for Project: #p.getName()#">

	<cfoutput>
	<h1 id="project_view" style="border-top: none; padding-top: 0;">#p.getName()#</h1>
	
	<p>
	There <cfif issues.recordcount neq 1>are<cfelse>is</cfif> #issues.recordCount#
	<cfif not structKeyExists(form, "filter")>
		total issue(s).
	<cfelse>
		issue(s) in this filter.
	</cfif>	
	</p>	
	</cfoutput>

	
	<cfoutput>
	<script>
	function show(u) {
			if(u != '') window.open(u,'fromlhp','directories=yes,location=yes,menubar=yes,resizable=yes,scrollbar=yes,status=yes,titlebar=yes,toolbar=yes')
	}
	</script>
	</cfoutput>


	<cfoutput>
	<p>
	<form action="project_view.cfm?id=#url.id#" method="get" name="projectform">
	<fieldset>
		<legend>Filter Issues</legend>	
		<input type="hidden" name="filter" value="y">
		<input type="hidden" name="id" value="#url.id#">
		<select name="bugtype_filter" onChange="document.projectform.submit()">
		<option value="">All Issue Types</option>
		<option value="Bug" <cfif url.bugtype_filter is "Bug">selected</cfif>>Bug</option>
		<option value="Enhancement" <cfif url.bugtype_filter is "Enhancement">selected</cfif>>Enhancement</option>
		</select>
					
		<select name="loci_filter" onChange="document.projectform.submit()">
		<option value="">All Loci</option>
		<cfloop query="possibleLoci">
			<option value="#id#" <cfif url.loci_filter is id>selected</cfif>>#name#</option>
		</cfloop>
		</select>
					
		<select name="severity_filter" query="application.severities" queryposition="below" value="id" display="name" onChange="document.projectform.submit()">
		<option value="">All Severities</option>
		<cfloop query="application.severities">
			<option value="#id#" <cfif url.severity_filter is id>selected</cfif>>#name#</option>
		</cfloop>
		</select>

		<select name="status_filter" query="application.statuses" queryposition="below" value="id" display="name" onChange="document.projectform.submit()">
		<option value="">All Statuses</option>
		<cfloop query="application.statuses">
			<option value="#id#" <cfif url.status_filter is id>selected</cfif>>#name#</option>
		</cfloop>
		</select>

		<select name="owner_filter" query="possibleUsers" queryposition="below" value="id" display="name" onChange="document.projectform.submit()">
		<option value="">All Users</option>
		<cfloop query="possibleUsers">
			<option value="#id#" <cfif url.owner_filter is id>selected</cfif>>#name#</option>
		</cfloop>
		</select>
		
		<input type="text" name="keyword_filter" value="#url.keyword_filter#"> <input type="submit" value="Keyword Search">
	</fieldset>
	</form>
	</p>
	</cfoutput>
	
	<cfmodule template="customtags/datatable.cfm" data="#issues#" editlink="view.cfm" label="Issue" linkcol="name" querystring="#qs#" sort="created" dir="desc">
		<cfmodule template="customtags/datacol.cfm" colname="name" label="Name" />
		<cfmodule template="customtags/datacol.cfm" colname="bugtype" label="Type" />
		<cfmodule template="customtags/datacol.cfm" colname="locusname" label="Locus" />		
		<cfmodule template="customtags/datacol.cfm" colname="severityname" label="Severity" />
		<cfmodule template="customtags/datacol.cfm" colname="statusname" label="Status" />
		<cfmodule template="customtags/datacol.cfm" colname="username" label="Owner" />
		<cfmodule template="customtags/datacol.cfm" colname="created" label="Created" format="date"/>
		<cfmodule template="customtags/datacol.cfm" colname="updated" label="Updated" format="date"/>
	</cfmodule>
	
			
</cfmodule>