<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\projectloci_edit.cfm
	Author       : Raymond Camden 
	Created      : 12/21/05
	Last Updated : 1/11/06
	History      : Version 2(rkc 12/22/05)
				 : typo'd vean for bean
--->

<!--- Only admins can run this file. --->
<cfif not isUserInRole("admin")>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<cfif not structKeyExists(url, "id")>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<cfif not url.id is 0>
	<cfset bean = application.projectLocusDAO.read(url.id)>
<cfelse>
	<cfset bean = createObject("component", "components.ProjectLocusBean")>
</cfif>
		
<cfset errormsg = "">

<cfparam name="form.name" default="#bean.getName()#">

<cfif isDefined("form.cancel")>
	<cflocation url="projectloci.cfm" addToken="false">
</cfif>


<cfif isDefined("form.save")>
	<cfset bean.setName(form.name)>
	<cfset errors = bean.validate()>
	<cfif arrayLen(errors)>
		<cfloop index="x" from="1" to="#arrayLen(errors)#">
			<cfset errormsg = errormsg & "#errors[x]#<br>">
		</cfloop>
	<cfelse>
		<!--- attempt to update --->
		<cftry>
			<cfif bean.getID() neq 0>
				<cfset application.projectLocusDAO.update(bean)>
			<cfelse>
				<cfset application.projectLocusDAO.create(bean)>
			</cfif>			

			<cflocation url="projectloci.cfm" addToken="false">
			<cfcatch>
				<cfset errormsg = cfcatch.message>
			</cfcatch>
		</cftry>
	</cfif>
</cfif>

<cfmodule template="customtags/layout.cfm" title="User Edit">

	<cfoutput>
	<h1 id="preferences" style="border-top: none; padding-top: 0;">Project Loci Edit</h1>
	<p>
	Use the form below to edit a project loci. Project Loci are simply bug/issue locations. 
	</p>
	</cfoutput>
	
	<cfif len(errormsg)>
		<cfoutput>
		<p>
		<b>The following error(s) has occured:</b><br>
		#errormsg#
		</p>
		</cfoutput>
	</cfif>

	<cfoutput>
	<form action="projectloci_edit.cfm?id=#url.id#" method="post">
	<table border="0">
		<tr>
			<td class="requiredField">Name:</td>
			<td><input type="text" name="name" value="#form.name#" class="textField"></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="cancel" value="Cancel"> <input type="submit" name="save" value="Save"></td>
		</tr>
	</table>
	</form>
	</cfoutput>
		

</cfmodule>

