<cfsetting enablecfoutputonly=true showdebugoutput=false>
<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\rss_view.cfm
	Author       : Raymond Camden 
	Created      : 3/28/04
	Last Updated : 12/22/05
	History      : Version 2, fixed a bug with links(rkc 12/22/05)
--->

<!--- security check --->
<cfif not isDefined("url.id") or not len(url.id)>
	<cfabort>
</cfif>


<cfset userBean = application.userManager.getUserByUsername(getAuthUser())>
<cfset roles = application.userManager.getGroupsForUser(session.userBean.getID())>
<cfif not listFindNoCase("admin", roles)>
	<!--- If not a root user, ensure they can access project --->
	<cfset projects = application.projectManager.getProjectsForUser()>
	<cfset projectlist = valueList(projects.id)>
	<cfif not listFind(projectlist, url.id)>
		<cfabort>
	</cfif>
<cfelse>
	<cfset projects = application.projectManager.getProjects()>
	<cfset projectlist = valueList(projects.id)>
</cfif>


<cfset userid = userBean.getID()>

<cfif url.id is -1>
	<cfset issues = application.issueManager.getIssuesForUserID(userid)>
<cfelseif url.id is 0>
	<cfset issues = application.issueManager.getIssuesForProjects(projectlist)>
<cfelse>
	<cfset issues = application.issueManager.getIssuesForProject(url.id)>
</cfif>

<cfif cgi.server_port is 80>
	<cfset lighthouseProURL = "http://">
<cfelse>
	<cfset lighthouseProURL = "https://">
</cfif>
<cfset lighthouseProURL = lighthouseProURL & cgi.server_name & listDeleteAt(cgi.script_name, listlen(cgi.script_name,"/"), "/")>

<cfset z = getTimeZoneInfo()>

<cfcontent type="text/xml"><cfoutput><?xml version="1.0" encoding="iso-8859-1"?>

<rdf:RDF 
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns##"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns="http://purl.org/rss/1.0/"
>
	<channel rdf:about="#lighthouseProURL#">
	<title>Lighthouse Pro</title>
	<description>Lighthouse Pro Bug Tracker</description>
	<link>#lighthouseProURL#</link>
	
	<items>
		<rdf:Seq>
			<cfloop query="issues">
			<rdf:li rdf:resource="#lighthouseProURL#/view.cfm?#xmlFormat("id=#id#")#" />
			</cfloop>
		</rdf:Seq>
	</items>
	
	</channel>
</cfoutput>

		<cfloop query="issues">
		<cfset dateStr = dateFormat(updated,"yyyy-mm-dd")>
		<cfset dateStr = dateStr & "T" & timeFormat(updated,"HH:mm:ss") & "-" & numberFormat(z.utcHourOffset,"00") & ":00">
		<cfoutput>
  	<item rdf:about="#lighthouseProURL#/view.cfm?#xmlFormat("id=#id#")#">
	<title>Project: #xmlFormat(projectname)# / Issue: #xmlFormat(name)#</title>
	<description><cfif len(description) gte 500>#xmlFormat(left(description,500))#...<cfelse>#xmlFormat(description)#</cfif></description>
	<link>#lighthouseProURL#/view.cfm?#xmlFormat("id=#id#")#</link>
	<dc:date>#dateStr#</dc:date>
	<dc:subject></dc:subject>
	</item>
		</cfoutput>
	 	</cfloop>

<cfoutput>
</rdf:RDF>
</cfoutput>

