<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\project_view.cfm
	Author       : Raymond Camden 
	Created      : 3/4/04
	Last Updated : 1/11/06
	History      : Version 2(rkc 12/22/05)
				 : Don't show loci for projects that do not have them. (rkc 1/11/06)
--->

<!--- 
	  Bugs we get depend on the choice, however, the top two override. So if pick
	  option 0 or -1, we ignore the other ones.
--->
<cfparam name="form.projects" default="">
<cfif listLen(form.projects) gte 2>
	<!--- My Issues gets trumped by All projects --->
	<cfif listFind(form.projects, 0)>
		<cfset form.projects = 0>
	<cfelseif listFind(form.projects,-1)>
		<cfset form.projects = -1>
	</cfif>
</cfif>

<cfif isUserInRole("admin")>
	<cfset myProjects = application.projectManager.getProjects()>
<cfelse>
	<cfset myProjects = application.projectManager.getProjectsForUser()>
</cfif>

<cfif (isDefined("form.submit_charts") or isDefined("form.submit_excel")) and len(form.projects)>
	<!--- get issues depending on filters --->
	<cfset projectlist = "">
	<cfif form.projects is 0>
		<cfset projectlist = valueList(myProjects.id)>
	<cfelseif form.projects is -1>
		<cfset userid = application.userManager.getUserByUsername(getAuthUser()).getID()>
	<cfelse>
		<cfset projectlist = form.projects>
	</cfif>

	<cfif not isDefined("userid")>
		<cfset issues = application.issueManager.getIssuesForProjects(projectlist)>
	<cfelse>
		<cfset issues = application.issueManager.getIssuesForUserID(userid)>
		<!--- quick way to get unique projects --->
		<cfset projects = structNew()>
		<cfloop query="issues">
			<cfset projects[projectidfk] = "">
		</cfloop>
		<cfset projectlist = structKeyList(projects)>
	</cfif>

	<cfset statuses = application.issueManager.getStatuses()>
	<cfset severities = application.issueManager.getSeverities()>

	<cfset loci = application.projectManager.getLociForProjects(projectlist)>
	
	<cfif isDefined("form.submit_charts")>
			
		<!--- generate totals for all descriptors --->
		<cfset data = structNew()>
		<cfloop list="#projectlist#" index="projectidfk">
			<cfset data[projectidfk] = structNew()>
			<cfset data[projectidfk].bugtypes = structNew()>
			<cfset data[projectidfk].bugtypes.bug = 0>
			<cfset data[projectidfk].bugtypes.enhancement = 0>
			<cfset data[projectidfk].statuses = structNew()>
			<cfloop query="statuses">
				<cfset data[projectidfk].statuses[id] = 0>
			</cfloop>
			<cfset data[projectidfk].severities = structNew()>
			<cfloop query="severities">
				<cfset data[projectidfk].severities[id] = 0>
			</cfloop>
			<cfset data[projectidfk].loci = structNew()>
			<cfloop query="loci">
				<cfset data[projectidfk].loci[id] = 0>
			</cfloop>
		</cfloop>
		
		
		<cfloop query="issues">
			<cfif structKeyExists(data, projectidfk)>
				<cfif isBug>
					<cfset data[projectidfk].bugtypes.bug = data[projectidfk].bugtypes.bug + 1>
				<cfelse>
					<cfset data[projectidfk].bugtypes.enhancement = data[projectidfk].bugtypes.enhancement + 1>
				</cfif>
				<cfset data[projectidfk].statuses[statusidfk] = data[projectidfk].statuses[statusidfk] + 1>			
				<cfset data[projectidfk].severities[severityidfk] = data[projectidfk].severities[severityidfk] + 1>
				<!--- loci is going to be a bit funky. Not all projects share the same loci --->			
				<cfset data[projectidfk].loci[locusidfk] = data[projectidfk].loci[locusidfk] + 1>
			</cfif>
		</cfloop>

	<cfelseif isDefined("submit_excel")>

		<cfsetting showdebugoutput=false>
		<cfcontent TYPE="application/msexcel">
		<cfheader name="content-disposition" value="attachment;filename=stats.xls">  
	
		<cfoutput>
		<table border="1">
			<tr bgcolor="yellow">
				<td filter="all"><b>Project</b></td>
				<td><b>Name</b></td>
				<td filter="all"><b>Owner</b></td>
				<td filter="all"><b>Issue Type</b></td>
				<td filter="all"><b>Locus</b></td>
				<td filter="all"><b>Severity</b></td>
				<td filter="all"><b>Status</b></td>
				<td><b>Created</b></td>
				<td><b>Updated</b></td>
			</tr>
		</cfoutput>
		
		<cfset projects = structNew()>
		<cfset users = structNew()>
		<cfset locusdata = structNew()>
		<cfset sevdata = structNew()>
		<cfset statdata = structNew()>
		<cfoutput query="issues">
			<cfif not structKeyExists(projects, projectidfk)>
				<cfset projects[projectidfk] = application.projectDAO.read(projectidfk)>
			</cfif>
			<cfif not structKeyExists(users, useridfk)>
				<cfset users[useridfk] = application.userDAO.read(useridfk)>
			</cfif>
			<cfif not structKeyExists(locusdata, locusidfk)>
				<cfset lid = locusidfk>
				<cfloop query="loci">
					<cfif loci.id is lid>
						<cfset locusdata[lid] = name>
						<cfbreak>
					</cfif>
				</cfloop>
			</cfif>
			<cfif not structKeyExists(sevdata, severityidfk)>
				<cfset sid = severityidfk>
				<cfloop query="severities">
					<cfif severities.id is sid>
						<cfset sevdata[sid] = name>
						<cfbreak>
					</cfif>
				</cfloop>
			</cfif>
			<cfif not structKeyExists(statdata, statusidfk)>
				<cfset sid = statusidfk>
				<cfloop query="statuses">
					<cfif statuses.id is sid>
						<cfset statdata[sid] = name>
						<cfbreak>
					</cfif>
				</cfloop>
			</cfif>

			<tr>
				<td>#projects[projectidfk].getName()#</td>
				<td>#name#</td>
				<td>#users[useridfk].getName()#</td>
				<td><cfif isBug>Bug<cfelse>Enhancement</cfif></td>
				<td>#locusdata[locusidfk]#</td>
				<td>#sevdata[severityidfk]#</td>
				<td>#statdata[statusidfk]#</td>
				<td>#dateFormat(created,"mm/dd/yy")# #timeFormat(created,"hh:mm tt")#</td>
				<td>#dateFormat(updated,"mm/dd/yy")# #timeFormat(updated,"hh:mm tt")#</td>
			</tr>
		</cfoutput>
		
		<cfoutput>
		</table>
		</cfoutput>
		
		<cfabort>
			
	</cfif>
	
</cfif>

<cfmodule template="customtags/layout.cfm" title="Stats">

	<cfoutput>
	<h1 id="stats" style="border-top: none; padding-top: 0;">Stats</h1>
	<p>
	Select one or more projects below to generate stats.
	</p>
	</cfoutput>
	
	<cfif myProjects.recordCount>
	
		<cfoutput>
		<form action="#cgi.script_name#" method="post" >
		
			<select name="projects">
			<option value="0" <cfif form.projects is 0>selected</cfif>>All Projects</option>
			<option value="-1" <cfif form.projects is -1>selected</cfif>>All Projects (My Issues)</option>
			<cfloop query="myProjects">
				<cfoutput><option value="#id#" <cfif listFind(form.projects,id)>selected</cfif>>#name#</option></cfoutput>
			</cfloop>
			</select>
			
			<input type="submit" name="submit_charts" value="Display Charts">
			<input type="submit" name="submit_excel" value="Excel Report">
			
		</form>
		</cfoutput>
		
	<cfelse>
	
		<cfoutput>
		<p>
		There are no projects available for you.
		</p>
		</cfoutput>
		
	</cfif>
	
	<cfif isDefined("form.submit_charts")>
	
		<cfset projects = structNew()>

		<cfoutput>
		<table cellspacing="10" ><tr><td>
		</cfoutput>
		<cfoutput>
		<cfsavecontent variable="chart">	
		<cfchart showLegend="true" show3d=true>
		
			<cfloop item="pid" collection="#data#">
				<cfif not structKeyExists(projects, pid)>
					<cfset project = application.projectDAO.read(pid)>
					<cfset projects[pid] = project>
				</cfif>
				<cfchartseries type="bar" serieslabel="#projects[pid].getName()#">
					<cfchartdata item="Bug" value="#data[pid].bugtypes.bug#">
					<cfchartdata item="Enhancement" value="#data[pid].bugtypes.enhancement#">
				</cfchartseries>

			</cfloop>
			
		</cfchart>
		</cfsavecontent>	
		
		
		#replacenocase(chart, "http://", "https://", "All")#
		</td><td>
		</cfoutput>
		<cfoutput>
		<cfsavecontent variable="chart">	
		<cfchart showLegend="true" show3d=true>
		
			<cfloop item="pid" collection="#data#">
				<cfchartseries type="bar" seriesLabel="#projects[pid].getName()#">
					<cfloop query="statuses">
						<cfchartdata item="#name#" value="#data[pid].statuses[id]#">
					</cfloop>
				</cfchartseries>
			</cfloop>
			
		</cfchart>
		</cfsavecontent>	
		
		
		#replacenocase(chart, "http://", "https://", "All")#
		
		</td></tr><tr><td colspan="2">
		</cfoutput>
		<cfoutput>
		<cfsavecontent variable="chart">	
		
		<cfchart showLegend="true" show3d=true>
		
			<cfloop item="pid" collection="#data#">
				<cfchartseries type="bar" seriesLabel="#projects[pid].getName()#">
					<cfloop query="severities">
						<cfchartdata item="#name#" value="#data[pid].severities[id]#">
					</cfloop>
				</cfchartseries>

			</cfloop>
			
		</cfchart>
		</cfsavecontent>	
		
		
		#replacenocase(chart, "http://", "https://", "All")#
		
		</td></tr><td colspan="2">
		</cfoutput>
		<cfoutput>
		<cfsavecontent variable="chart">	
		<cfchart showLegend="true" show3d=true chartwidth="500">
		
			<cfloop item="pid" collection="#data#">
				<cfchartseries type="bar" seriesLabel="#projects[pid].getName()#">
					<cfloop query="loci">
						<cfchartdata item="#name#" value="#data[pid].loci[id]#">
					</cfloop>
				</cfchartseries>

			</cfloop>
			
		</cfchart>
		</cfsavecontent>	
		
		
		#replacenocase(chart, "http://", "https://", "All")#
		
		</td></tr></table>
		</cfoutput>

	</cfif>
		
</cfmodule>
