<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\user_edit.cfm
	Author       : Raymond Camden 
	Created      : 12/21/05
	Last Updated : 12/29/05
	History      : version 2.0 is in the house... (rkc 12/22/05)
				   can't change username for current user, thanks to Critter (rkc 12/28/05)
				   case fix (rkc 12/29/05)
--->

<!--- Only admins can run this file. --->
<cfif not isUserInRole("admin")>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<cfif not structKeyExists(url, "id")>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<cfset projects = application.projectManager.getProjects()>

<cfif not url.id is 0>
	<cfset uBean = application.userDAO.read(url.id)>
	<cfset groups = application.userManager.getGroupsForUser(url.id)>
	<cfset myprojects = application.projectManager.getProjectsForUser(uBean.getUsername())>
	<cfset myprojects = valueList(myprojects.id)>
	<cfset mysubprojects = application.projectManager.getEmailProjectsForUser(uBean.getUsername())>
	<cfset mysubprojects = valueList(mysubprojects.id)>
<cfelse>
	<cfset uBean = createObject("component", "components.UserBean")>
	<cfset groups = "">
	<cfset myprojects = "">
	<cfset mysubprojects = "">
</cfif>
		
<cfset errormsg = "">

<cfparam name="form.username" default="#uBean.getUsername()#">
<cfparam name="form.password" default="#uBean.getPassword()#">
<cfparam name="form.emailaddress" default="#uBean.getEmailAddress()#">
<cfparam name="form.name" default="#uBean.getName()#">
<cfif not isDefined("form.save")>
	<cfparam name="form.projects" default="#myprojects#">
	<cfparam name="form.emailprojects" default="#mysubprojects#">
<cfelse>
	<cfparam name="form.projects" default="">
	<cfparam name="form.emailprojects" default="">
</cfif>

<cfif listFind(groups, "admin")>
	<cfparam name="form.admin" default="true">
<cfelse>
	<cfparam name="form.admin" default="false">
</cfif>

<cfif isDefined("form.cancel")>
	<cflocation url="users.cfm" addToken="false">
</cfif>

<cfif isDefined("form.save")>
	<cfset uBean.setUsername(form.username)>
	<cfset uBean.setPassword(form.password)>
	<cfset uBean.setName(form.name)>
	<cfset uBean.setEmailAddress(form.emailaddress)>
	<cfset errors = uBean.validate()>
	<cfif arrayLen(errors)>
		<cfloop index="x" from="1" to="#arrayLen(errors)#">
			<cfset errormsg = errormsg & "#errors[x]#<br>">
		</cfloop>
	<cfelse>
		<!--- attempt to update --->
		<cftry>
			<cfif uBean.getID() neq 0>
				<cfset application.userDAO.update(uBean)>
			<cfelse>
				<cfset application.userDAO.create(uBean)>
			</cfif>
			
			<cfif form.admin>
				<cfset application.userManager.setGroupsForUser(uBean.getID(),application.admingroupid)>
			<cfelse>
				<cfset application.userManager.setGroupsForUser(uBean.getID())>
			</cfif>
			<cfset application.projectManager.setProjectsForUser(uBean.getID(), form.projects)>

			<!-- don't let them subscribe to a project they aren't assigned to. --->
			<cfloop index="x" from="#listLen(form.emailprojects)#" to="1" step="-1">
				<cfif not listFindNoCase(form.projects, listGetAt(form.emailprojects, x))>
					<cfset form.emailprojects = listDeleteAt(form.emailprojects, x)>
				</cfif>
			</cfloop>
			<cfset application.projectManager.setEmailProjectsForUser(uBean.getID(), form.emailprojects)>

			<cflocation url="users.cfm" addToken="false">
			<cfcatch>
				<cfset errormsg = cfcatch.message>
			</cfcatch>
		</cftry>
	</cfif>
</cfif>

<cfmodule template="customtags/layout.cfm" title="User Edit">

	<cfoutput>
	<h1 id="preferences" style="border-top: none; padding-top: 0;">User Edit</h1>
	<p>
	Use the form below to edit a user. You may also assign a user to projects as well as subsribe them as well.
	</p>
	</cfoutput>
	
	<cfif len(errormsg)>
		<cfoutput>
		<p>
		<b>The following error(s) has occured:</b><br>
		#errormsg#
		</p>
		</cfoutput>
	</cfif>

	<cfoutput>
	<form action="user_edit.cfm?id=#url.id#" method="post">
	<table border="0">
		<tr>
			<td class="requiredField">Username:</td>
			<td>
			<!--- Idea for this by Critter --->
			<cfif form.username is getAuthUser()>
			<input type="hidden" name="username" value="#form.username#">
			#form.username# (Username for current user cannot be changed.)
			<cfelse>
			<input type="text" name="username" value="#form.username#" class="textField">
			</cfif>
			</td>
		</tr>
		<tr>
			<td class="requiredField">Password:</td>
			<td><input type="text" name="password" value="#form.password#" class="textField"></td>
		</tr>
		<tr>
			<td class="requiredField">Email:</td>
			<td><input type="text" name="emailaddress" value="#form.emailaddress#" class="textField"></td>
		</tr>
		<tr>
			<td class="requiredField">Name:</td>
			<td><input type="text" name="name" value="#form.name#" class="textField"></td>
		</tr>
		<tr>
			<td class="nonrequiredField">Projects:</td>
			<td>
			<select name="projects" multiple size="5" class="dropdownField">
			<cfloop query="projects">
				<cfoutput><option value="#id#" <cfif listFind(form.projects, id)>selected</cfif>>#name#</option></cfoutput>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td class="nonrequiredField">Email Projects:</td>
			<td>
			<select name="emailProjects" multiple size="5" class="dropdownField">
			<cfloop query="projects">
				<cfoutput><option value="#id#" <cfif listFind(form.emailprojects, id)>selected</cfif>>#name#</option></cfoutput>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td class="requiredField">Admin:</td>
			<td>
			<input type="radio" name="admin" <cfif form.admin>checked</cfif> value="yes">Yes<br />
			<input type="radio" name="admin" <cfif not form.admin>checked</cfif> value="no">No<br />
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="cancel" value="Cancel"> <input type="submit" name="save" value="Save"></td>
		</tr>
	</table>
	</form>
	</cfoutput>
		

</cfmodule>

