<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\users.cfm
	Author       : Raymond Camden 
	Created      : 3/4/04
	Last Updated : 12/22/05
	History      : Version 2(rkc 12/22/05)
--->

<!--- Only admins can run this file. --->
<cfif not isUserInRole("admin")>
	<cflocation url="index.cfm" addToken="false">
</cfif>
	
<!--- handle deletest --->
<cfif isDefined("form.mark")>
	<cfloop index="id" list="#form.mark#">
		<cfset application.UserDAO.delete(id)>
	</cfloop>
</cfif>
	
<cfset users = application.UserManager.getUsers()>
<!---
	  For security purposes, we are simply an admin or not.
	  We need to add that flag to the query.
--->
<cfif left(server.COLDFUSION.PRODUCTVERSION, 1) eq 6>
	<cfset evaluate('queryAddColumn(users,"admin",arrayNew(1))')>
<cfelse>
	<cfset evaluate('queryAddColumn(users,"admin","varchar",arrayNew(1))')>
</cfif>
	
<cfloop query="users">
	<cfset groups = application.userManager.getGroupsForUser(id)>
	<cfif listFindNoCase(groups,"admin")>
		<cfset querySetCell(users,"admin","Yes",currentRow)>
	<cfelse>
		<cfset querySetCell(users,"admin","No",currentRow)>
	</cfif>
</cfloop>

<cfmodule template="customtags/layout.cfm" title="Users">

	<cfoutput>
	<h1 id="users" style="border-top: none; padding-top: 0;">User Editing</h1>
	<p>
	Use the form below to select a user to modify. You may also add a new user or delete an existing user.
	</p>
	</cfoutput>

	<cfmodule template="customtags/datatable.cfm" data="#users#" editlink="user_edit.cfm" label="User" linkcol="name">
		<cfmodule template="customtags/datacol.cfm" colname="name" label="Name" />
		<cfmodule template="customtags/datacol.cfm" colname="username" label="Username" />
		<cfmodule template="customtags/datacol.cfm" colname="emailaddress" label="Email Address" format="email"/>
		<cfmodule template="customtags/datacol.cfm" colname="admin" label="Admin" format="yesno"/>
	</cfmodule>


</cfmodule>