<!---
	Name         : C:\projects\lighthousepro\wwwroot\lighthousepro\view.cfm
	Author       : Raymond Camden 
	Created      : 3/4/04
	Last Updated : 1/6/06
	History      : Version 2(rkc 12/22/05)
				 : Changed disabled to readonly (12/29/05)
				 : fix header for new issue (rkc 1/6/06)
				 : Default to me (rkc 1/11/06)
--->

<!--- check for ID --->
<cfif not isDefined("url.id")>
	<cflocation url="index.cfm" addToken="false">
</cfif>

<!--- read issue --->
<cfif url.id is not 0>
	<cfset i = application.issueDAO.read(url.id)>
	<cfset p = application.projectDAO.read(i.getProjectIDFK())>
<cfelse>
	<cfset i = createObject("component", "components.IssueBean")>
	<cfset p = application.projectDAO.read(url.pid)>
</cfif>

<!--- If not an admin, ensure this user has the right to read this issue. --->
<cfif not isUserInRole("admin")>
	<cfset myProjects = application.projectManager.getProjectsForUser()>
	<cfif not listFindNoCase(valueList(myProjects.id), p.getID())>
		<cflocation url="index.cfm" addToken="false">
	</cfif>
</cfif>

<!--- used to store error msg --->
<cfset errormsg = "">


<!--- handle events --->
<cfif isDefined("form.cancel")>
	<cflocation url="project_view.cfm?#cgi.query_string#" addToken="false">
</cfif>

<cfif isDefined("form.print")>
	<cfoutput>
	<cfset output = application.issueManager.printFormat(i)>
	<script language=JavaScript>
		function PrintThisPage() 
		{
			window.print();
			window.close();
		} 
		window.onload = PrintThisPage;
	</script>
	<div style="font-family: Arial; font-size: 6px">Lighthouse Pro</div>
	<style>TD{ font-family: Arial; font-size: 12px;}</style>
	#output#
	</cfoutput>
	<cfabort>
</cfif>

<cfif isDefined("form.save")>
	<cfif url.id is  0>
		<cfset iBean = createObject("component","components.IssueBean")>
		<cfset iBean.setCreated(now())>
	<cfelse>
		<cfset iBean = application.IssueDAO.read(url.id)>
	</cfif>	
	<cfset iBean.setName(form.name)>
	<cfset iBean.setUpdated(now())>
	<cfset iBean.setProjectIDFK(p.getID())>
	<cfset iBean.setUseridfk(form.useridfk)>
	<cfset iBean.setDescription(form.description)>
	<cfset iBean.setRelatedURL(form.relatedurl)>
	<!--- History is a combo of the old history plus notes marked by your username and date. --->
	<!--- for a new bug, typically notes is blank. We will add a Created marker ahead though. --->
	<cfset me = application.UserManager.getUserByUsername(getAuthUser())>
	
	<cfif url.id is 0>
		<cfset history = "Created by #getAuthUser()# (#me.getName()#) : #dateFormat(now(),'mm/dd/yy')# #timeFormat(now(),'h:mm tt')#">
	<cfelse>
		<cfset history = iBean.getHistory() & "Updated by #getAuthUser()# (#me.getName()#) : #dateFormat(now(),'mm/dd/yy')# #timeFormat(now(),'h:mm tt')#">
	</cfif>
	<cfset history = history & chr(10)>
	<cfif len(trim(form.notes))>
		<cfset history = history & form.notes & chr(10)>
	</cfif>
	<cfset history = history & chr(10)>	
	<cfset iBean.setHistory(history)>
	<cfset iBean.setIsBug(form.isbug)>
	<cfset iBean.setLocusIDFK(form.locusidfk)>
	<cfset iBean.setSeverityIDFK(form.severityidfk)>
	<cfset iBean.setStatusIDFK(form.statusidfk)>

	<cfif len(form.newattachment)>
		<cffile action="upload" destination="#application.attachmentpath#" filefield="newattachment" nameconflict="makeunique">
		<cfset newfile = Duplicate(cffile)>
		<cfif newfile.fileWasSaved>
			<cfset iBean.setAttachment(newfile.serverfile)>
		</cfif>
	</cfif>
	
	<cfset errors = iBean.validate()>
	<cfif arrayLen(errors)>
		<cfloop index="x" from="1" to="#arrayLen(errors)#">
			<cfset errorMsg = errorMsg & "#errors[x]#">
		</cfloop>
	<cfelse>
		<cftry>
			<cfif url.id is 0>
				<cfset iBean = application.IssueDAO.create(iBean)>
				<cfset application.IssueManager.emailNotifications(iBean.getID())>
			<cfelse>
				<cfset oldBean = application.issueDAO.read(url.id)>
				<cfset iBean = application.IssueDAO.update(iBean)>
				<cfset application.IssueManager.emailNotifications(iBean.getID(),oldBean)>
			</cfif>
			<cflocation url="project_view.cfm?#cgi.query_string#" addToken="false">
			<cfcatch>
				<cfset errormsg = cfcatch.message & "<br>" & cfcatch.detail>
			</cfcatch>
		</cftry>
	</cfif>
</cfif>

<cfparam name="form.name" default="#i.getName()#">
<cfparam name="form.isbug" default="#i.getIsBug()#">
<cfparam name="form.locusidfk" default="#i.getLocusIDFK()#">
<cfparam name="form.severityidfk" default="#i.getSeverityIDFK()#">
<cfparam name="form.statusidfk" default="#i.getStatusIDFK()#">
<cfparam name="form.relatedurl" default="#i.getRelatedURL()#">
<cfif i.getID() is 0>
	<!--- default to me, because I rock. --->
	<cfset userid = application.userManager.getUserByUsername(getAuthUser()).getID()>
	<cfparam name="form.useridfk" default="#userid#">
<cfelse>
	<cfparam name="form.useridfk" default="#i.getUserIDFK()#">
</cfif>


<cfparam name="form.description" default="#i.getDescription()#">
<cfparam name="form.history" default="#i.getHistory()#">
<cfparam name="form.attachment" default="#i.getAttachment()#">
<cfparam name="form.notes" default="">

<!--- get loci --->
<cfset possibleLoci = application.projectManager.getLociForProject(p.getID())> 
<!--- get users --->
<cfset possibleUsers = application.projectManager.getUsersForProject(p.getID())>


<cfif i.getID() is 0>
	<cfset title = "New Issue">
<cfelse>
	<cfset title = "Issue: " & i.getName()>
</cfif>

<cfmodule template="customtags/layout.cfm" title="#title#">


	<cfif len(errormsg)>
		<cfoutput>
		<p>
		<b>The following error(s) has occured:</b><br>
		#errormsg#
		</p>
		</cfoutput>
	</cfif>

	<cfoutput>
	<cfif i.getID() is 0>
	<h1 id="issue" style="border-top: none; padding-top: 0;">New Issue</h1>
	<cfelse>
	<h1 id="issue" style="border-top: none; padding-top: 0;">Issue: #i.getName()#</h1>
	</cfif>
	
	<p>
	<form action="view.cfm?#cgi.query_string#" method="post" enctype="multipart/form-data" id="form1" name="form1">
	<table border="0">
		<cfif i.getID() is not 0>
		<tr>
			<td class="requiredField">Tracking ID:</td>
			<td>#i.getID()#</td>
		</tr>
		</cfif>
		<tr>
			<td class="requiredField">Name:</td>
			<td><input type="text" name="name" value="#form.name#" class="textField"></td>
		</tr>
		<tr>
			<td class="requiredField">Project:</td>
			<td>#p.getName()#</td>
		</tr>
		<tr>
			<td class="requiredField">Type:</td>
			<td>
			<select name="isbug" class="dropdownField">
			<option value="1" <cfif form.isBug>selected</cfif>>Bug</option>
			<option value="0" <cfif not form.isBug>selected</cfif>>Enhancement</option>
			</select>
			</td>
		</tr>
		<tr>
			<td class="requiredField">Locus:</td>
			<td>
			<select name="locusidfk" class="dropdownField">
			<cfloop query="possibleLoci">
			<option value="#id#" <cfif form.locusidfk is id>selected</cfif>>#name#</option>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td class="requiredField">Severity:</td>
			<td>
			<select name="severityidfk" class="dropdownField">
			<cfloop query="application.severities">
			<option value="#id#" <cfif form.severityidfk is id>selected</cfif>>#name#</option>
			</cfloop>
			</select>
			</td>
		</tr>
		<tr>
			<td class="requiredField">Status:</td>
			<td>
			<select name="statusidfk" class="dropdownField">
			<cfloop query="application.statuses">
			<option value="#id#" <cfif form.statusidfk is id>selected</cfif>>#name#</option>
			</cfloop>
			</select>			
			</td>
		</tr>
		<tr>
			<td class="nonrequiredField">Related URL:</td>
			<td>
			<input type="text" name="relatedurl" value="#form.relatedurl#" class="textField">
			<cfif len(trim(form.relatedurl))>
			<br />
			<a href="#form.relatedurl#">Go to URL</a>
			</cfif>
			</td>
		</tr>
		<tr>
			<td class="nonrequiredField">Attachment:</td>
			<td>
			<cfif len(trim(form.attachment))>
			<a href="attachments/#urlEncodedFormat(form.attachment)#">#form.attachment#</a>
			<cfelse>
			No attachment.
			</cfif>
			<br />Upload New Attachment: <input type="file" name="newattachment" class="textField">
			</td>
		</tr>
		<tr>
			<td class="requiredField">Owner:</td>
			<td>
			<select name="useridfk" class="dropdownField">
			<cfloop query="possibleUsers">
			<option value="#id#" <cfif form.useridfk is id>selected</cfif>>#name# (#username#)</option>
			</cfloop>
			</select>
			</td>
		</tr>		
		<tr>
			<td class="requiredField">Created:</td>
			<td>#dateFormat(i.getCreated(),"mm/dd/yy")# #timeFormat(i.getCreated(),"h:mm tt")#</td>
		</tr>
		<tr>
			<td class="requiredField">Last Updated:</td>
			<td>#dateFormat(i.getUpdated(),"mm/dd/yy")# #timeFormat(i.getUpdated(),"h:mm tt")#</td>
		</tr>
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td class="requiredField">Description:</td>
			<td><textarea name="description" class="textareaField">#form.description#</textarea></td>
		</tr>
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td class="nonrequiredField">History:</td>
			<td><textarea name="history" class="textareadisabledField" readonly="true">#form.history#</textarea></td>
		</tr>
		<cfif i.getID() is not 0>
		<tr>
			<td class="nonrequiredField">Add Notes:</td>
			<td><textarea name="notes" class="notesField">#form.notes#</textarea></td>
		</tr>
		<cfelse>
		<input type="hidden" name="notes" value="">
		</cfif>	
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="cancel" value="Cancel" onClick="document.form1.target = '';"> <cfif i.getID() is not 0><input type="submit" name="print" value="Print" onClick="document.form1.target = '_blank';"> </cfif><input type="submit" name="save" value="Save" onClick="document.form1.target = '';"></td>
		</tr>
		
	</table>
	</p>
	</cfoutput>

</cfmodule>
